function [centers eliminateProj vecs validCenters]= bifurcationDetection(projPointsf,Y,indPC,params,Rtrace,projVecs)

X = projPointsf(:,indPC)';
Xvec = squeeze(projVecs(:,1,indPC))';
% check if clusters belong to fiber, blue soma or background
% Xcolor = params.f2(indPC,:);
% XLabcolor = params.f3(indPC,:);

pD = (pdist2(X,Y));
pD = min(pD,[],2);

eliminateProj = indPC(pD<params.Bif.Rmin);
vecs=[];

if params.Bif.varThr
    bif = pD<params.Bif.Rmax &pD>Rtrace(:);
else
    bif = pD<params.Bif.Rmax &pD>params.Bif.Rmin;
end
indbf = find(any(bif,2));
dataBfP = X(indbf,:);
dataVecBfP = Xvec(indbf,:);
% dataColorBfP = Xcolor(indbf,:);
% dataColorLabBfP = XLabcolor(indbf,:);

paramsMS = params;
paramsMS.sptSig = params.MS.sptSig;    %to find bifurcations use a smaller spt. kernel
paramsMS.colSig = params.MS.colSig;    %to find bifurcations use a smaller spt. kernel
paramsMS.featDimC=0;
paramsMS.featDimP=3;
paramsMS.featDim=paramsMS.featDimC+paramsMS.featDimP;

if(0)
    % Apply mean shift algorithm
    [~, ~, ~, ~, centers] = meanShift(dataBfP',paramsMS);
else
    D  = dist(dataBfP').^2; % Compute Distance Matrix
    options.dims = 1:10;
    options.verbose = 0;
    if isempty(D)
        centers=[];
        validCenters=[];
        return;
    end
%     [D_new] = IsomapIID(D, 'k', size(D,1), options); %http://isomap.stanford.edu
D_new = D;
    [ar_mode2, iter, Dclust, S] = medoidshift(D_new,paramsMS.sptSig,dataBfP'); % Complete Medoidshift Algorithm
    B = unique(ar_mode2);
    % if returned weighted pairwise mode distances are very small, merge them
    Dm = triu(Dclust<params.Bif.ClusterDistThr);
    Dm(1:length(Dclust)+1:end) = 0;
    [a b] = find(Dm);
    for i=1:size(a,1)
        ar_mode2(ar_mode2 == B(a(i))) = B(b(i));
    end
    B = unique(ar_mode2);
%%    
    c = zeros(1,length(B));
    validCenters = zeros(1,length(B));
    V = zeros(params.featDimP,length(B));
    for i=1:length(B)
        c(i)=sum(ar_mode2==B(i));
        if nargout>2 & c(i)>params.Bif.clusterSize
           indmembers = find(ar_mode2==B(i));
           if params.remCheck
            temp=dataBfP(indmembers,:);
            temp = temp-repmat(mean(temp,1),c(i),1);
            [v,~]=eigs(temp'*temp,1);
            V(:,i) = v;
            else
                temp=dataVecBfP(indmembers,:);
                temp=repmat(sign(temp*temp(1,:)'),1,params.featDimP).*temp;
                V(:,i) = normr(median(temp));
            end
           
%            feat1 = dataColorLabBfP(indmembers,params.featDimP+1)<1.5;
%            feat2 = dataColorLabBfP(indmembers,end)>-.4;
%            if all(feat2)
%                validCenters(i)=1;
% %            elseif any(feat1|feat2) & sum(feat1&feat2)>2
% %                validCenters(i)=1;
%            end

        end
    end
    centers = dataBfP(B(c>params.Bif.clusterSize),:)';
    centers2 = dataBfP(B(c>params.Bif.clusterSize & validCenters),:)';
    if nargout>2
        vecs = V(:,(c>params.Bif.clusterSize));
    end
 %%       
    if params.visual
        visualizeClustering(ar_mode2,dataBfP'); % Visualize Result
        title(sprintf('Medoidshift Result: %d Iterations',iter));
    end
    
    
    
    
end
%%
if params.visual
    hold on,plot(Y(:,2),Y(:,1),'r.')
    hold on,plot(centers2(2,:),centers2(1,:),'ro', 'MarkerSize',12)
    hold on,plot(centers(2,:),centers(1,:),'g>')
%     hold on,plot(centers(2,bifurFlag),centers(1,bifurFlag),'g>')
%     xlim([0 520])
%     ylim([0 520])
%     zlim([0 100])
end

