function [centers eliminateProj]= bifurcationDetection(projPointsf,PC,numOfFiber,indPC,params)

X = projPointsf(:,indPC)';
Y = [PC{numOfFiber}.Trajectory_fSub]';

pD = (pdist2(X,Y));
pD = min(pD,[],2);

% bif = pD<12;
% indbf = find(any(bif,2));

% figure(30),
% hold on,plot3(X(indbf,3),X(indbf,2),X(indbf,1),'g.')
eliminateProj = indPC(pD<4);

bif = pD<12 &pD>4;
indbf = find(any(bif,2));
dataBfP = X(indbf,:);

paramsMS = params;
% paramsMS.sptSig = 3;    %to find bifurcations use a smaller spt. kernel
% paramsMS.colSig = .5;    %to find bifurcations use a smaller spt. kernel
paramsMS.sptSig = params.MS.sptSig;    %to find bifurcations use a smaller spt. kernel
paramsMS.colSig = params.MS.colSig;    %to find bifurcations use a smaller spt. kernel
% paramsMS = fitkde_(dataBfP',1,0,[-2 5])
% [sigma_opt,cov_x] = fitkde(dataBfP',1)
paramsMS.featDimC=0;
paramsMS.featDimP=3;
paramsMS.featDim=paramsMS.featDimC+paramsMS.featDimP;



if(0)
    % Apply mean shift algorithm
    [~, ~, ~, ~, centers] = meanShift(dataBfP',paramsMS);
else
    % Apply medioidshift with ISOMAP
    %     D  = dist(dataBfP').^2; % Compute Distance Matrix
    %     [ar_mode2, iter] = medoidshift(D,5); % Complete Medoidshift Algorithm
    %     visualizeClustering(ar_mode2,dataBfP'); % Visualize Result
    %     title(sprintf('Medoidshift Result: %d Iterations',iter));
    D  = dist(dataBfP').^2; % Compute Distance Matrix
    options.dims = 1:10;
    options.verbose = 0;
    if isempty(D)
        centers=[];
        return;
    end
    [D_new] = IsomapIID(D, 'k', size(D,1), options); %http://isomap.stanford.edu
    [ar_mode2, iter, Dclust, S] = medoidshift(D_new,paramsMS.sptSig,dataBfP'); % Complete Medoidshift Algorithm
    B = unique(ar_mode2);
    % if returned weighted pairwise mode distances are very small, merge them
    Dm = triu(Dclust<5);
    Dm(1:length(Dclust)+1:end) = 0;
    [a b] = find(Dm);
    for i=1:size(a,1)
        ar_mode2(ar_mode2 == B(a(i))) = B(b(i));
    end
    B = unique(ar_mode2);
    
    c = zeros(1,length(B));
    for i=1:length(B)
        c(i)=sum(ar_mode2==B(i));
    end
%     c/sum(c)>
    centers = dataBfP(B(c>3),:)';
    if params.visual
        visualizeClustering(ar_mode2,dataBfP'); % Visualize Result
        title(sprintf('Medoidshift Result: %d Iterations',iter));
    end
end
%%
if params.visual
    hold on,plot3(Y(:,3),Y(:,2),Y(:,1),'r.')
    xlim([0 520])
    ylim([0 520])
    zlim([0 100])
end

