function [Kf Kp Kc]=kernel_matrix(data1,data2,n,N1,N2,params)
% Calculates the kernel density estimate K(x) and K(x-xi) for point x
anisotropic = params.ani;
invCi = params.invCi;
K = zeros(N1,N2);
Kx_xi = zeros(n,N2);
if anisotropic
    for i=1:N2
        t1 = (data1 - repmat(data2(:,i),1,N1));
        t2 = invCi(:,(i-1)*n+1:n*i)*t1;
        Ci = 1*sqrt(det(invCi(:,(i-1)*n+1:n*i)))/((2*pi)^(n/2));
        K(:,i) = Ci*exp(-0.5*sum(t1.*t2,1));
        Kx_xi(:,i) = t1*K(:,i);
    end
else
  
    t1 = (repmat(data1(1:params.featDimP),1,N2) - data2(1:params.featDimP,:));
%     t1 = t1./repmat([1.1^2;1^2;1^2],1,N2);
%     t2 = t1./repmat([params.sptSigx^2;params.sptSigy^2;params.sptSigz^2],1,N2);
    t2 = t1/params.sptSig^2;


    % Cpi = 1/(2*pi*params.sptSig^2)^(params.featDimP/2)/(erf(params.sptW/params.sptSig));
    Cpi = 1/(2*pi*params.sptSig^2)^(params.featDimP/2);
    if isinf(params.sptSig)
        Cpi=1;
    end
    Kp = Cpi*exp(-0.5*sum(t1.*t2,1));
    
    % weuc = @(XI,XJ,W)((bsxfun(@minus,XI,XJ).^2 * W'));
    % tic;for i=1:1000;(pdist2(y',x', @(Xi,Xj) weuc(Xi,Xj,[1 1 1])));end;toc

    if 0
        Kp = exp(-0.5*sum(t1.*t2,1));
    end

    t1 = (repmat(data1(params.featDimP+1:end),1,N2) - data2(params.featDimP+1:end,:));
    t2 = t1/params.colSig^2;
    Cci = 1/(2*pi*params.colSig^2)^(params.featDimC/2);
    
    Kc = Cci*exp(-0.5*sum(t1.*t2,1));
    
    if 0
        Kc = exp(-0.5*sum(t1.*t2,1));
    end
    
    Kf = Kp.*Kc;
    
end
end
% params.eps.eps = 2.65;
% params.eps.Ceps = 1/(params.eps.eps*sqrt(2*pi)*erf(1/sqrt(2)))^3;
% t1 = (repmat(data1(1:params.featDim.P),1,N2) - data2(1:params.featDim.P,:));
% t2 = t1/params.eps.eps^2;
% Cpi = params.eps.Ceps*10;
% Kp = Cpi*exp(-0.5*sum(t1.*t2,1));
% sum(Kp)
% figure, plot(Kp)
% %%
% params.sigC=3;
% t1 = (repmat(data1(params.featDim.P+1:end),1,N2) - data2(params.featDim.P+1:end,:));
% t2 = t1/params.sigC^2;
% Cci = 1/(2*pi*params.sigC^2)^(params.featDim.C/2);
% % Cci=.1;
% Kc = Cci*exp(-0.5*sum(t1.*t2,1));
% sum(Kc)
% % figure, plot(Kc)
% figure, plot(Kp),hold on, plot(Kc,'r.')
% %%
% Kf = Kp.*Kc;
