% function mainHippo(directory,dataset)
% Main of Hippo Projection Fibers

% Data Information
% Experimental Procedures:

% Z distance between successive images within an image stack: 3.40 pixel
% Spacings : X&Y = 0.3296485 microns, Z =1 microns
%%%%%%%%%%%%%%%%%
% Manual Reconstruction Information
% OP_1 (X,Y,Z): (30.979,429.04,0.000); Training tree; Manual reconstruction provided
% OP_2 (X,Y,Z): (0.72501,391.08,25); Training tree; Manual reconstruction provided
% OP_3 (X,Y,Z): (93.742,179,38); Training tree; Manual reconstruction provided
% OP_4 (X,Y,Z): (128.2,504.37,0.303); Scored tree; Manual reconstruction not provided
% OP_5 (X,Y,Z): (185.7,264.02,33); Scored tree; Manual reconstruction not provided
% OP_6 (X,Y,Z): (15.074,412.01,10); Scored tree; Manual reconstruction not provide
%%%%%%%%%%%%%%%%%
% NOTE: x,y,z (above) is defined for image domain, in order to make
% notation consistent with Matlab, I converted the indexces to X,Y,Z, so in
% the code the order is as follows
%               --- Z = x-->
%              /|
%             / |
%       Y = y/  |
%               |
%            X = z


addpath(genpath([cd '/mfiles']))
beginn = 1;
if (beginn)
    clear all;close all;clc
    % Keep parameters inside params
    % # of images:
    % NC1:60;NC2:33;NC3:44;NC4:51;NC5:50;NC6:46;
    params.numOfImages = [135;120;105;82];
    
    params.zdist = 1;%3.40;
    
    seedxyz{1} = [4183,563,80;4503,1172,113;4063,861,108; 3907,869,110;3889,839,111;3613,902,112;
        3357,1573,116;1912,2550,0;2466,1512,115];
    seedxyz{2} = [2341,286,117;2094,790,101;1001,1336,55;967,1807,119;760,1864,57;770,2001,60];
    seedxyz{3} = [2478,702,23;2487,726,84;3024,336,16;2417,823,88;2465,723,16;2443,846,19;3373,1037,15;
        3513,1382,20;2045,547,5;1452,832,22;2938,1533,25;589,1871,26;866,2066,30;3262,1263,92];
    seedxyz{4} = [2710,281,6;3534,1073,10;2725,1126,13;1885,703,5;1152,1174,12;336,1985,13];
    datasizes=[5896,3040,135;3752,2660,120;4288,3040,105;3752,2280,82];
    
    params.dataset =3;
%     switch params.dataset
        %case 3
            for i=1
                
                seed = seedxyz{params.dataset};%(:,3) seedxyz(:,2) seedxyz(:,1)];
                params.tangVecprev = [1;-1;1];   %initial direction of pc
                params.sptSig = 2.5;
                params.colSig = .5;
                params.kernelWeightFactor = .2; %power of the weight term in tracing step
                params.Factors.neig=2;  % weights of vectorial tracing
                params.Factors.vprev=1;
                params.Tracing.lenTang=1;    %tangent vec
                params.Tracing.lenVal=1;  %color
                params.branchFibStart = 4;
                params.Bif.varThr = false;
                params.Bif.remLowThr = .5;
                params.Bif.Rmin = 4;
                params.Bif.Rmax = 14;
                params.Bif.clusterSize = 3;
                params.Bif.ClusterDistThr = 5;
                params.Bif.centroidImtensityThr = .3;
                params.Bif.intensityThr = .05;
                params.remIntensityThr = .15;
                params.IntensityThr = .1;
                params.MS.sptSig = 3;    %to find bifurcations use a smaller spt. kernel
                params.MS.colSig = .5;    %to find bifurcations use a smaller spt. kernel
                params.varSig = true;
                params.varSigMax = 7;
                params.varSigMin = 2.5;
                params.varSigMinBound = 1.5;
                x=[17 27];
                y=[params.varSigMax params.varSigMin];
                a=(y(2)-y(1))/(x(2)-x(1));
                b=y(1)-a*x(1);
                params.varSigCoef = [a,b];
                
                params.smoothImages = true;
                
                params.forePerc = 100;
                params.filt = true;
                
                params.dim.x = datasizes(params.dataset,1);
                params.dim.y = datasizes(params.dataset,2);
                params.dim.z = datasizes(params.dataset,3);
                
                params.seeds = seed;
                
                
           end
%     end
    f=[];
    params.directory = ['C:/ERHAN/WORK/DATA/DIADEM/Hippocampal CA3/TEMP_Hippocampal CA3 Interneuron/Image Stacks/Qualifier Image Stacks/Section_0',num2str(params.dataset+1)];
    for j=params.dataset
        % Load Images
        j
        params.zdown = 1;
        params.xdown = 4;
        IM=zeros(params.numOfImages(j),round(params.dim.y/params.xdown),round(params.dim.x/params.xdown),3);
        dim = size(IM);
        for i=1:dim(1)
            loadName = sprintf('%s/%03d.tif',params.directory,i);
            imtemp = (imread(loadName));
            h = fspecial('gaussian',[18 18],3);
            if params.smoothImages
                imtemp2 = imfilter(imtemp,h);
                %                 im = imresize(imtemp,.5);
            end
            IM(i,:,:,:) = imresize(imtemp2,[dim(2) dim(3)]);
        end
        %%
        data = IM;
        %         dim = size(IM);
        %         data = zeros([dim(1) dim(2)/2 dim(3) 3]);
        %         dim = size(data);
        %         for i=1:size(Gcl,2)
        %             data(:,i,:)=imresize(squeeze(IM(:,i,:)),dim,'nearest');
        %         end
        
        %%
        %         clear imtemp imtemp2
        
        %         data = IM;
        [dataMIP indMIP]= min(data,[],1);
        dataMIPori = squeeze(dataMIP);
        dataMIP = squeeze(dataMIP);
        indMIP = squeeze(indMIP);
        dataVec = reshape(dataMIP,numel(dataMIP)/3,3);
        maxMIP = max(dataVec);
        minMIP = min(dataVec);
        dataVec = (dataVec-repmat(minMIP,length(dataVec),1))./(repmat(maxMIP-minMIP,length(dataVec),1));
        dataMIP = reshape(dataVec,dim(2:4));
        
        dataMIPLab = rgb2lab((dataMIP));
        dataVec = reshape(dataMIPLab,numel(dataMIP)/3,3);
        maxMIP = max(dataVec);
        minMIP = min(dataVec);
        dataVec = (dataVec-repmat(minMIP,length(dataVec),1))./(repmat(maxMIP-minMIP,length(dataVec),1));
        dataMIPLab = reshape(dataVec,dim(2:4));
        %%
        imex = dataMIP(:,:,1) <eps;
        w1 = dataMIPLab(:,:,2);%<.85;
        w2 = dataMIP(:,:,1);%<.9;
        se = strel('square',15);
        imex = imdilate(imex,se);
        
        [GMP]= colorGrad(dataMIP/max(dataMIP(:)),0,'2D');
        GMP = GMP/max(GMP(:));
        
        %         figure, imshow(GMP)
        GMP(imex) = 0;
        %         figure, imshow(GMP)
        se = strel('square',4);
        GMP2=imclose(abs(GMP),se);
        %         figure, imshow(GMP2)
        %%
        parfor d=1:dim(1)
            G(d,:,:)= colorGrad(squeeze(data(d,:,:,:)));
        end
        %%
        G = abs(G); G = G/max(G(:));
        
        GMIP = max(G,[],1);
        GMIP = squeeze(GMIP);
        
        GMIP(imex) = 0;
        se = strel('square',4);
        GMIP2=imclose(abs(GMIP),se);
        %%
        figure, imshow(GMP2)
        figure, imshow(GMIP2)
        %%
        Gfinal = GMP2>.07;
        figure, imshow(dataMIP)
        figure, imshow(Gfinal)
        hold on, plot(seed(:,1)/params.xdown,seed(:,2)/params.xdown,'oy','MarkerSize',16)
        %%
        z = indMIP(Gfinal);
        [y x] = find(Gfinal);
        p = [y x];
        N = length(p);
        IndI = zeros(1,prod(dim(2:3)));
        indforeIm = sub2ind(dim(2:3),p(:,1),p(:,2));
        IndI(indforeIm) = 1:N;
        dataVec = reshape(dataMIP,numel(dataMIP)/3,3);
        f = [p dataVec(indforeIm,:)];
        
        k=250;  %500->R~5, 250->R~4
        F = [p randn(length(p),1)];
        ptrtree=BuildGLTree(F);
        [KNNG,distances]=KNNSearch(F(:,1:3),F(:,1:3),ptrtree,k);
        
        %%
    end
    
    
    %     clear dataMIPLab dataMIPori IM
    %     clearvars -except f foreIm dim data params dataVec KNNG IndI k N
    %%
    fori=f;
    
    %%
    f=fori;
    %%
    clc
    indknn_ = 1:k;
    
    % f=f(:,2:end);
    
    params.featDimP = 2;
    params.featDimC = 3;
    params.featDim = params.featDimC + params.featDimP;
    
    params.ani = 0;
    params.invCi = [];
    params.invCxi=[];
    params.knnNum = k;
    params.fullH = 0;   %0-> uses only Hpp, 1: full H
    
    % params.sptSigx = params.sptSig;
    % params.sptSigy = params.sptSig;
    % params.sptSigz = params.sptSig;
    params.scale = 1;
    params.normalUpdateThr = 5;
    Inext=zeros(params.featDimP,length(KNNG));
    
    
    % Calculate initial PC projections
    projPoints1 = zeros(params.featDimP,N);
    projPointsf1 = zeros(params.featDimP,N);
    projVecs1 = zeros(params.featDimP,params.featDimP,N);
    % Covx1 = zeros(3,3,N);
    % matlabpool(4)
    f(:,3:end) = f(:,3:end)./repmat(max(f(:,3:end)),N,1);
    f(:,3:end) = 1-f(:,3:end)./repmat(max(f(:,3:end)),N,1);
    f(:,3:end) = f(:,3:end)./repmat(max(f(:,3:end)),N,1);
    tic
    params.sptSig = 5;
    params.zdist = 1;
    params.colSig = .2;
    
    
    
    
    parfor indexOfVoxel=1:N
        sptSig = params.sptSig;
        if ~mod(indexOfVoxel,1000)
            indexOfVoxel
        end
        indknn = KNNG(indexOfVoxel,1:k);
        f_i = f(indknn,:)';
        x = f_i(:,end);
        xg = round(x(1:params.featDimP));
        
        wkernel = sum(f_i(params.featDimP+1:end,:),1); wkernel = wkernel/sum(wkernel);
        %     wkernel = 1-wkernel;
        
        [pcUpdate_normal subSpace pctang SI vals] = pcProj(x,f_i,params,wkernel,sptSig);
        proj_normalD = pcUpdate_normal;%./[params.zdist;1;1];
        it = 1;
        ind_it=1;
        
        if any(abs(proj_normalD) >params.normalUpdateThr) %| params.f3(indexOfVoxel,end)<params.Bif.traj.bthr
            continue;
        else
            %             while any(abs(pcUpdate_normal./[params.zdist;1;1])>.05) &  ind_it & it<=100
            while any(abs(pcUpdate_normal)>.05) &  ind_it & it<=100
                wkernel = sum(f_i(params.featDimP+1:end,:),1); wkernel = wkernel/sum(wkernel);
                %             wkernel = 1-wkernel;
                [pcUpdate_normal subSpace pctang SI vals] = pcProj(x,f_i,params,wkernel,sptSig);
                proj_normalD = proj_normalD + pcUpdate_normal;
                x(1:params.featDimP) = x(1:params.featDimP) + pcUpdate_normal;
                %                 hold on, plot3(x(3),x(2),x(1),'g.')
                xg = round(x(1:params.featDimP));
                xg = max([1;1],xg);
                xg = min(dim(2:3)',xg);
                %             ind_it = IndI(sub2ind((dim(1:params.featDimP)),xg(1,:),xg(2,:),xg(3,:)));
                ind_it = IndI(sub2ind((dim(2:3)),xg(1,:),xg(2,:)));
                if ~ind_it %| any(abs(pcUpdate_normal./[params.zdist;1;1]) >params.normalUpdateThr)
                    continue;
                end
                x(params.featDimP+1:end) = f(ind_it,(params.featDimP+1:end));
                
                indknn = KNNG(ind_it,1:k);
                f_i = f(indknn,:)';
                it = it+1;
            end
            
            if it>100 | ~ind_it
                continue;
            end
            
            projPoints1(:,indexOfVoxel) = xg;
            projPointsf1(:,indexOfVoxel) = x(1:params.featDimP);
            projVecs1(:,:,indexOfVoxel) = [pctang(:) subSpace];
            temp = inv(SI);
            Covx1(:,:,indexOfVoxel) = sign(temp(1))*temp;
        end
    end
    toc
    %%
    close all
    Im2 = squeeze(data(50,:,:,:));Im2 = Im2/max(Im2(:));
    %
    params.varSig = 0;
    if 1
        if ~params.varSig
            indPC = find(any(projPointsf1));
            projPointsSet = projPointsf1(:,indPC);
            figure,
            imtemp = Im2;%squeeze(Im2(25,:,:,:));
            imshow(imtemp,[]),hold on,
            plot(projPointsSet(2,:),projPointsSet(1,:),'g.')
            title([num2str(params.sptSig),';',num2str(params.colSig),';',num2str(params.normalUpdateThr)])
            projPoints = projPoints1;
            projPointsf = projPointsf1;
            projVecs = projVecs1;
            Covx = Covx1;
        else
            indPC = find(any(projPointsf2));
            projPointsSet = projPointsf2(:,indPC);
            figure,
            imshow(squeeze(Im2(14,:,:,:)),[]),hold on,
            plot3(projPointsSet(3,:),projPointsSet(2,:),projPointsSet(1,:),'g.')
            title([num2str(params.colSig),';',num2str(params.sptSig),';',num2str(params.normalUpdateThr)])
            projPoints = projPoints2;
            projPointsf = projPointsf2;
            projVecs = projVecs2;
            Covx = Covx2;
        end
    end
    
    figure,
    imtemp = Im2;%squeeze(Im2(25,:,:,:));
    imshow(imtemp,[]),hold on,
    indVals = sum(f(find(any(round(projPointsf(:,:)),1)),4),2)>.4;
    hold on, plot(projPointsSet(2,indVals),projPointsSet(1,indVals),'r.')
    
    % projPointsf =  projPointsf<5
% fback = f;
f = [ones(length(f),1) f];
    
end
%%  Trace a fiber
params.visual = 0;
numOfFiber=1;
indforeIm = sub2ind(dim(2:3),p(:,1),p(:,2));
params.f2 = GMIP2(indforeIm);
PC=[];
PCAll = [];
params.fig=31;
params.visual = 0;
params.featDimP = 3;
bifCheck = 0;
seed = params.seeds;% -repmat(minBound,length(params.seeds),1);

numOfTrace = 1;
tangVecprev = params.tangVecprev;
params.Bif.Rmax = 10;
params.Tracing.lenTang = 5;
PC=[];
for seedNumber = 1:size(seedxyz{params.dataset},1)
    params.seed = seedxyz{params.dataset}(seedNumber,[3 2 1])./[params.zdown params.xdown params.xdown];
    params.seed(1)=1;
    if seedNumber == 1
        params.seed = [1 73 597];
    end
    indexOfSeed=find(all(f(:,1:params.featDimP)==repmat((round(params.seed(1:3))),length(f),1),2));
    params.initSeed = indexOfSeed;
    if isempty(indexOfSeed)
        x = f(:,1:params.featDimP);
        y=params.seed(1:3);
        [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
    end
    
    indknn = KNNG(indexOfSeed,1:params.knnNum);
    f_i = f(indknn,:)';
    w_i = sum(f(indknn,params.featDimP+1:end),2).^(-1);    w_i = (w_i/sum(w_i)).^.5;
    
    wf_i = (f_i(1:params.featDimP,:)-repmat(f_i(1:params.featDimP,end),1,params.knnNum)).*repmat(w_i',params.featDimP,1);
    wcov = cov(wf_i');
    [a b] = eig(wcov);
    [~,indb] = sort(diag(b),'descend');
    a=a(:,indb);
    
    tangVecprev = [a(:,1)];
    % tangVecprev = [0;1];
    initSeed = indexOfSeed;
    params.dim.z = dim(1);
    params.remCheck = 0;
    params.permute=0;
    
    params.filt = 0;
    params.f_filt = f;
    
    params.dim.x = dim(3);    params.dim.y = dim(2);    params.dim.z = dim(1);
    params.varSptSig = 0;
    params.Tracing.lenTang =5;
    params.Bif.centroidImtensityThr = 0;
    % params.minBound = minBound;
    params.IntensityThr = .0001;
    Im2 = data;%sum(data,4);
    
    
    f = [1*ones(length(f),1) fback];
    params.featDimP = 3;
    params.featDim = 6;
    params.sptSig = 2;
    
    [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1] = branchIt(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,initSeed,projPoints,projPointsf,projVecs,PCAll,params);
    [PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
    % check any remaning points
    params.remCheck = 1;
    
    params.Bif.Rmin = 5;
    params.Bif.Rmax = 15;
    endTrace = 0;
    params.Factors.neig = 4
    iteration = 1;
    while ~endTrace
        [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1 endTrace] = checkRem(f,Im2,KNNG,IndI,PC1,numOfFiber1,[],projPointsRem1,projPointsfRem1,projVecs,PCAll1,params);
        title(num2str(iteration))
        iteration = iteration+1;
    end
    [PC,numOfFiber,PCAll,projPoints,projPointsf] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
    numOfFiber = numOfFiber+1;
end
%%
for i=1:size(seedxyz{params.dataset},1)
    params.seed = seedxyz{params.dataset}(i,[3 2 1])./[params.zdown params.xdown params.xdown];
    params.seed(1)=1;
    if i == 1
        params.seed = [1 73 597];
    end
    indexOfSeed=find(all(f(:,1:params.featDimP)==repmat((round(params.seed(1:3))),length(f),1),2));
    if isempty(indexOfSeed)
        x = f(:,1:params.featDimP);
        y=params.seed(1:3);
        [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
    end

    indRoots(i) = indexOfSeed; 
end

params.indRoots = indRoots;
%%
[SWC2 S2 pickOne] = createConMatrix2(PC,f,params);
%%
SWC3=SWC2;
% directory = params.directory;
for i=1:length(SWC2)
    SWC3{i}(:,[3 4 5]) = SWC2{i}(:,[3 4 5]).*repmat([ params.xdown params.xdown params.zdown],size(SWC2{i},1),1);
    SWC_ = SWC3{i};
    numOfTrace=1;
    file_1 = fopen([directory,'Qual_NC_',num2str(numOfTrace),'SWC',num2str(pickOne(i)),'.swc'],'w');
    fprintf(file_1,'# Neurolucida to SWC conversion from L-Measure.\n');
    fprintf(file_1,'%d %d %4.3f %4.3f %4.3f %d %d\n',SWC_');
    fclose(file_1);
%     isconnected(S2)
end
% 
% z = indMIP(indforeIm);
% T = [];
% for i=1:length(PC)
%     T_ = [z(PC{i}.Trajectory)'; PC{i}.Trajectory_fSub(2:3,:)];
%     T=[T T_]
% end
% 
% 
% %%
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% %%
% for i=1:length(seed)
%     params.seed = ceil(seed(i,:)./[params.zdown params.xdown params.xdown]);
%     indexOfSeed=find(all(cfori==repmat(params.seed(1:params.featDimP),length(f),1),2),1);
%     if isempty(indexOfSeed)
%         x = fori(:,1:params.featDimP);
%         y=params.seed;
%         [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
%     end
%     
%     indRoots(i) = indexOfSeed;
% end
% 
% params.indRoots = indRoots;
% %%
% for numOfTrace=2:length(seed)
%     if numOfTrace == 15
%         stop=1;
%     end
%     params.seed = ceil(seed(numOfTrace,:)./[params.zdown params.xdown params.xdown]);
%     indexOfSeed=find(all(cfori==repmat(params.seed(1:params.featDimP),length(f),1),2),1);
%     indRoots(numOfTrace) = indexOfSeed;
%     params.initSeed = indexOfSeed;
%     if isempty(indexOfSeed)
%         x = fori(:,1:params.featDimP);
%         y=params.seed;
%         [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
%     end
%     
%     indknn = KNNG(indexOfSeed(1),1:params.knnNum);
%     f_i = f(indknn,:)';
%     w_i = f(indknn,4);    w_i = (w_i/sum(w_i)).^.5;
%     
%     wf_i = (f_i(1:params.featDimP,:)-repmat(f_i(1:params.featDimP,end),1,params.knnNum)).*repmat(w_i',params.featDimP,1);
%     wcov = cov(wf_i');
%     [a b] = eig(wcov);
%     [~,indb] = sort(diag(b),'descend');
%     a=a(:,indb);
%     
%     tangVecprev = a(:,1);
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
%     numOfFiber1 = numOfFiber1+1;
%     
%     [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1] = branchIt(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC1,numOfFiber1,initSeed,projPointsRem1,projPointsfRem1,projVecs1,PCAll1,params);
%     [PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
%     
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
%     
%     numOfFiber1 = numOfFiber1+1;
%     [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1] = branchIt(f,indexOfSeed,-tangVecprev,Im2,KNNG,IndI,PC1,numOfFiber1,initSeed,projPointsRem1,projPointsfRem1,projVecs1,PCAll1,params);
%     [PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
%     
% end
% %%
% 
% %%
% 
% for ty=1
%     %%
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
%     % check any remaning points
%     params.remCheck = 1;
%     endTrace = 0;
%     while ~endTrace
%         [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1 endTrace] = checkRem(f,Im2,KNNG,IndI,PC1,numOfFiber1,[],projPointsRem1,projPointsfRem1,projVecs,PCAll1,params);
%     end
%     %%
%     folder = 'C:/ERHAN/WORK/DATA/DIADEM/Neocortical Layer 6 Axons/Qualifier/';
%     % PC1=PC
%     [SWC1 S1 B1 wS1] = createConMatrix(PC1,f,params);
%     SWC1(:,5) = SWC1(:,5)*params.zdown;
%     SWC1(:,3:5) = SWC1(:,3:5) + repmat(minBound([3 2 1]),length(SWC1),1);
%     
%     file_1 = fopen([folder,'Qual_OF_Test_',num2str(numOfTrace),'vs_S1.swc'],'w');
%     fprintf(file_1,'# Neurolucida to SWC conversion from L-Measure.\n');
%     fprintf(file_1,'%d %d %4.3f %4.3f %4.3f %d %d\n',SWC1');
%     fclose(file_1);
%     isconnected(S1)
%     %%
% end
% 
