function [SWC Ssubsub pickOne] = createConMatrix2(PC,f,params)
%%
C = [];
Cf=[];
for i=1:length(PC)
    child = PC{i}.Trajectory(2:end)';
    parent = PC{i}.Trajectory(1:end-1)';
    if length(PC{i}.Trajectory) ~=size(PC{i}.Trajectory_fSub,2)
        i
    end
    C = [C;[child parent]];
    Cf = [Cf;PC{i}.Trajectory_fSub(:,2:end)'];
end
nS = max(C(:));
S = sparse(C(:,1),C(:,2),1,nS,nS);

S = S+S';
S(find(diag(S)),find(diag(S))) = 0;
indCluBig = find(sum(S,2)>0);  %non empty regions
N = length(indCluBig);
IndI = zeros(length(S),1);
IndI(indCluBig) = 1:N;

indR = IndI(params.indRoots);

C = [];
parfor i=1:N
    if ~mod(i,1000)
        i
    end
    edges = find(S(indCluBig(i),:))';
    Ci = [i*ones(length(edges),1) edges(:)];
    C = [C;Ci];
end
C2 = IndI(C(:,2));
C(:,2)=C2;
Ssub = sparse(C(:,1),C(:,2),1,N,N);

% check connectivity

[s,Clust] = graphconncomp(Ssub);
% find the memberships of the roots
validSeeds = find(indR>0);
memR = Clust(indR(validSeeds));

% possible root candidates
R = params.indRoots;

[modMem pickOne] = unique(memR,'first');
Rpicked = indR(validSeeds(pickOne));
Roripicked = R(validSeeds(pickOne));
% Rpicked = indR(modMem)
%%
clusterNum = 0;
for i=1:s
    if ~mod(i,1000)
        i
    end
    members = find(i==Clust);
    if length(members)==1
        continue;
    else
        clusterNum = clusterNum +1;
        ConS{clusterNum} = members;
    end
end
%%
for i=1:clusterNum
    %create a new graph
    indClu = ConS{i};
    %     find(sum(S,2)>0);  %non empty regions
    N = length(indClu);
    IndIsub = zeros(length(Clust),1);
    IndIsub(indClu) = 1:N;
    C = [];
    parfor j=1:N
        if ~mod(j,1000)
            j
        end
        edges = find(Ssub(indClu(j),:))';
        Cj = [j*ones(length(edges),1) edges(:)];
        C = [C;Cj];
    end
    C2 = IndIsub(C(:,2));
    C(:,2)=C2;
    Ssubsub = sparse(C(:,1),C(:,2),1,N,N);
%     Ssubsub = Ssubsub+Ssubsub';
    Ssubsub(1:N+1:end)=1;
%     Ssubsub = Ssubsub>0;
    [T,pred] = graphminspantree(Ssubsub,find(indClu==Rpicked(i)));%,'METHOD','Kruskal');
    
%     clear SWC;
    SWC{i} = zeros(N,7);
    for j=1:N
        SWC{i}(j,[1 2]) = [j 2];
        SWC{i}(j,3:5) = f(indCluBig(indClu(j)),[3 2 1]);
        SWC{i}(j,6) = 1;
        SWC{i}(j,7) = pred(j);
    end
    rootN=find(SWC{i}(:,7)==0);
    SWC{i}(rootN,7) = -1;
    
end
%%
%
% % [D,pred,cl] = graphtraverse(S,B(1,2));
% [~,pred] = graphminspantree(S,B(1,2),'METHOD','Kruskal');
% [b t j] = unique([B(1,2);B(:,1)]);
% Xperm = C(t,:); %permute X
% Xfperm = Cf(t,:);
%
% SWC = zeros(length(Xperm),7);
% for i=1:length(Xperm)
%     SWC(i,[1 2]) = [i 2];
%     SWC(i,3:5) = Xfperm(i,[3 2 1]);
%     SWC(i,6) = 1;
%     SWC(i,7) = pred(i);
% end
%
% SWC(:,5) = params.zdist*SWC(:,5);
% rootN=find(SWC(:,7)==0);
% SWC(rootN,7) = -1;
% % temp = SWC(1,:);
% % SWC(1,:)=SWC(rootN,:);
% % SWC(rootN,:)=temp;

end