function [K p gra H SI Hlogp msupdate] = pgh(x,data,params,weights)
% for a point x=[p;c], pgh calculates probability:(K), gradient:(gra),
% Hessian:(H=Hes|[Hpp Hpc;Hcp Hcc]), inverse of covariance:(SI), meanshift update, and Hessian
% of log(p):(Hlogp) based on the kernel density estimate using the data:(data) at point(x)
% with (weights).
%
% LOG:
% 12/04/09
% Changed couple lines toi make it more efficient and presentable
% 12/04/09
% I am still working on the selection of weights. Weights works as a background subtraction
% method and right now I use the normalized gray values, but a better strategy would be
% finding the weights that best seperates the current color from the others spatialy.In
% a normal setting gray values inside the fiber should have same weights,in order to do this,
% find the histogram of the fiber model and weight the voxels with the hist bins (similar to
% backprojection), or find  the paper that describes the methodology that finds the best
% projection

nOut = nargout;
anisotropic = params.ani;
invCi = params.invCi;
[~, Nx]=size(x);
invCxi = params.invCxi;
[dim Ndata] = size(data);
% N = params.knnNum; = Ndata

if nargin<4
    weights = ones(1,Nx);
else
    weights = weights(:);
end

% x(1:3) = x(1:3,:)./[params.sptSigx;params.sptSigy;params.sptSigz]; % scale the data
% data(1:3,:) = data(1:3,:)./repmat([params.sptSigx;params.sptSigy;params.sptSigz],1,Ndata); % scale the data
x(1:3) = x(1:3,:)./[params.zdist;1;1]; % scale the data
data(1:3,:) = data(1:3,:)./repmat([params.zdist;1;1],1,Ndata); % scale the data


% tic;params2 = fitkde(data(4:6,:),0,0,0,[-4 -1]);toc
% tic;params22 = fitkde2(data(4:6,:),0,0,0,[-4 -1]);toc
% para = fitkdeD(data(4:6,:),0,0,0,[-2 2]);
% params2 = fitkde(data(4:6,end-10:end),0,0,0,[log10(params.colSig)-1 log10(params.colSig)+1]);
% params.colSig = params2.sig;
% x = x./range(data')';
% data = data./repmat(range(data')',1,size(data,2));

for i=1:Nx,
%     [K Kp Kc]= kernel_matrix(x,data,dim,1,Ndata,params);
%     data(1,:) = data(1,:)/3;x(1)=x(1)/3;
     [K]= kernel_matrix(x,data,dim,1,Ndata,params);
%     data(1,:) = data(1,:)*3;x(1)=x(1)*3;
     K=K.*(weights.^1)';   %Weighted version
    
%     figure, plot(Kp/max(Kp)), hold on
%     plot(Kc/max(Kc),'r')
%     plot(weights/max(weights),'g')
    
    p= sum(K,2)/Ndata;
    if anisotropic
        for dd=1
            invCx = reshape(invCi'*x,dim,Ndata);
            invCxmData = invCx - invCxi;
            gra = -(invCxmData*K')/Ndata;
            temp1 = zeros(size(invCi));
            for d =1:dim
                temp1(:,d:dim:end) = invCxmData.*repmat(invCxmData(d,:),dim,1).*repmat(K,dim,1);
            end
            temp2 = temp1 - invCi.*reshape(repmat(K,dim^2,1),dim,dim*Ndata);
            H = reshape(sum(reshape(temp2(:),dim^2,Ndata),2)/Ndata,dim,dim);
            if nOut ==4
                SI = -((1/p)*H-(1/p)^2*(gra*gra'));
            elseif nOut == 5
                SI = -((1/p)*H-(1/p)^2*(gra*gra'));
                Hlogp = (1/p)*H-(1/p)^2*(gra*gra');
            end
        end
        
    else
        F = repmat(x,1,Ndata)-data;
        p_pi = (F(1:params.featDimP,:));
        c_ci = (F(params.featDimP+1:end,:));
        %         Cpi = 1/(2*pi*params.sptSig^2)^(params.featDimP/2)/(erf(params.sptW/params.sptSig));
        %         Cci = 1/(2*pi*params.colSig^2)^(params.featDimC/2);
        gra=(-1/Ndata)*[(1/params.sptSig^2)*sum(p_pi.*repmat(K,params.featDimP,1),2);
            (1/params.colSig^2)*sum(c_ci.*repmat(K,params.featDimC,1),2)];
        Hpp = (1/(Ndata*params.sptSig^4))*(repmat(K,params.featDimP,1).*p_pi)*p_pi'-eye(params.featDimP)*p/params.sptSig^2;
        
        if params.fullH
            Hcc = (1/(Ndata*params.colSig^4))*(repmat(K,params.featDimC,1).*c_ci)*c_ci'-eye(params.featDimC)*p/params.colSig^2;
            Hpc = (1/(Ndata*params.sptSig^2*params.colSig^2))*(repmat(K,params.featDimP,1).*p_pi)*c_ci';
            Hcp = Hpc';
            H = [Hpp Hpc;Hcp Hcc];
        else
            gra = gra(1:params.featDimP);
            H=Hpp;
        end
        
        if nOut ==5
            SI = -((1/p)*H-(1/p)^2*(gra*gra'));
        elseif nOut == 6
            SI = -((1/p)*H-(1/p)^2*(gra*gra'));
            Hlogp = (1/p)*H-(1/p)^2*(gra*gra');
        elseif nOut == 7
            SI = -((1/p)*H-(1/p)^2*(gra*gra'));
            Hlogp = (1/p)*H-(1/p)^2*(gra*gra');
            
            num = sum(repmat(K,params.featDim,1).*data,2);
            denum = sum(K,2);
            invdenum = 1/denum;
            f_new = invdenum*num;
            msupdate = f_new - x;
            if ~params.fullH
                msupdate = msupdate(1:params.featDimP); % Select only the ones effect the position
            end
        end
    end
end
end

