function [indFeature backModel] = background(IM,thrP,thrG)
% Calculate the background with GMM
maskedIm=[];
[n,h,w,~] = size(IM);
% Masks = zeros(n,h,w);
% figure,
maskParams.area = h*w/30;
maskParams.se =strel('disk',3); %
maskParams.thr=.05;

% matlabpool(5)

parfor i=1:n
    Im = squeeze(IM(i,:,:,:));
    [maskedImm ~] = createMask(Im,maskParams);
    maskedIm =[maskedIm;maskedImm];
end
l = length(maskedIm);
t = randperm(l);
data = double(maskedIm(t(1:min(100000,length(t))),:));
[alphas,means,mcovs]=mixturefit(data,3,1,1e-8);
ncomp=3;
backModel.ncomp = ncomp;
backModel.alphas = alphas;
backModel.means = means;
backModel.mcovs = mcovs;
tic
se = strel('disk',1);
%%
parfor i=1:n
%     i
    Im = squeeze(IM(i,:,:,:));
    Imvec = reshape(Im,numel(Im)/3,3);
    probs = pnormal(Imvec,means,mcovs,ncomp)*alphas;
    ftemp = sum(Imvec,2)/3>thrG;
    fortemp = ~(probs>thrP);
    forT = reshape(fortemp.*ftemp,h,w);
%     forT = reshape(ftemp,h,w);
    IforeOpen = imopen(forT,se);
    Ifore(i,:) = IforeOpen(:); %Select IforeClose for larger covarage or forT for obtained estimate
end
%%

% figure,
% for i=1:n
%     i
%     Im = squeeze(IM(i,:,:,:));
%     for l = 1:h*w
%         pix=double(Im([l l+h*w l+2*h*w]))/255;
%         probs = pnormal(pix,means,mcovs,ncomp)*alphas;
%         Iback(i,l) = probs>1e-010;
%     end
%     fortemp = ~Iback(i,:);
%     forT = reshape(fortemp,h,w);
%     IforeOpen = imopen(forT,se);
%     % IforeClose = imclose(forT,se);
%     Ifore(i,:) = IforeOpen(:); %Select IforeClose for larger covarage or forT for obtained estimate
% %     subplot(3,ceil(n/3),i), imshow(IforeOpen)
%     % figure, imshow(IforeOpen)
% end
%%
% matlabpool close

indFeature = Ifore(:); %Select foreground pixels
toc
