function [PC bifurFlag bifurTrace] = traceFiberRem(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,bifCheck,PCAll,initSeed,params)

%%  Trace a fiber
bifurFlag = 0;
bifurTrace=[];
dim = [params.dim.z params.dim.y params.dim.x];
i_nextInit = indexOfSeed;
pcUpdate_normal = [0;0;0];
indexOfVoxel=i_nextInit;

Trajectory=zeros(1,500);
t=1;

Vprev = normc(round(tangVecprev));
%Vprev = [0;0;0];
%     Create filters for pc value and tangent direction
lenTang=params.Tracing.lenTang;    %tangent vec
lenVal=params.Tracing.lenVal;  %color

pc_tanget = zeros(params.featDimP,lenTang);
pcf = zeros(params.featDimC,lenVal);

sigTang=20;  %learning rate for tangental comp
wTang = exp(-(0:lenTang-1)/sigTang);
wTang = wTang/sum(wTang);

sigVal=2;   %learning rate for color val
wVal = exp(-(0:lenVal-1)/sigVal);
wVal = wVal/sum(wVal);

pcUpdate_tangent_prev = tangVecprev;
% close all
Trajectory_fSub = zeros(params.featDimP,500);
while 1
    t;
    
    Trajectory(t)=indexOfVoxel;
    indknn = KNNG(indexOfVoxel,1:params.knnNum);
    f_i = f(indknn,:)';
    pcf(:,1)=f_i(params.featDimP+1:end,end);
    if params.filt
        pcf(:,1)=params.f_filt(indexOfVoxel,4);
    end
    
    currP = f_i(1:params.featDimP,end);
    params.sptSig = params.varSptSig(indexOfVoxel)*1;
    
    
    if params.visual    %display iterations
        figure(gcf),
        hold on,plot3(currP(3),currP(2),currP(1),'rv')
        for dum=1
            
            pos = round(f_i(1:3,end)./[params.zdist;1;1]);
            wdisp = 0;
            minpos = max(pos-wdisp,[1;1;1]);
            maxpos = min(pos+wdisp,dim');
            
            Im2(pos(1),pos(2),pos(3),:)=[1 0 0];
            Im2(minpos(1):maxpos(1),minpos(2):maxpos(2),...
                minpos(3):maxpos(3),1)=1;
            Im2(minpos(1):maxpos(1),minpos(2):maxpos(2),...
                minpos(3):maxpos(3),2)=0;
            Im2(minpos(1):maxpos(1),minpos(2):maxpos(2),...
                minpos(3):maxpos(3),3)=0;
            %             %
            if t>0 %&0
                imdisp=imresize(squeeze(Im2(pos(1),:,:,:)),1);
                imshow(imdisp/max(imdisp(:)),[]);%drawnow
                title(num2str(pos'));pos'
            end
        end
    end
    %
    %c=f_i(:,end);
    if t<lenVal
        c=pcf(:,1:t)*(wVal(1:t)/sum(wVal(1:t)))';
    else
        c = pcf*wVal';
        % c = median(pcf,2);
    end
    if params.remCheck
        intensityThr = params.remIntensityThr;
    else
        intensityThr = params.IntensityThr;
    end
    
    if c<intensityThr & t~=1  %t~=1 is heuristic, in order to prevent cases such that initial point is on background
        Trajectory(t) = [];
        %         Trajectory_fSub(:,t) = f(indexOfVoxel,1:3);
        bifurFlag =0;
        break;
    end
    
    % calculate the pgh
    [K_ori , ~, ~, ~, SI_ori , ~, ms_update] = pgh([currP;c],f_i,params,f_i(4,:).^params.kernelWeightFactor);
    %     ms_update = ms_update.*[params.zdist;1;1];
    sum(K_ori);
    % calculate the first eigen vector
    [vec vals] = eig(SI_ori);
    
    if t==1 %For the first voxel we dont need orthogonal correction since MS is on PC
        [~,ind] = sort(diag(vals),'ascend');
        vec = vec(:,ind);
        tangVec = vec(:,1);
        tracingUpdate = tangVec*sign(tangVecprev'*tangVec(1:params.featDimP));
        pc_tanget(:,1) = tracingUpdate(1:params.featDimP);  %position buffer
        if params.remCheck
            % problamatic centers are at bif. centers, so weight the initial direction
            tracingUpdate = .1*tracingUpdate(1:params.featDimP)+.9*tangVecprev;
        else
            tracingUpdate = tracingUpdate(1:params.featDimP);
        end
        pcUpdate_tangent = tracingUpdate(1:params.featDimP);
    else
        [~,ind] = sort(diag(vals),'ascend');
        vec = vec(:,ind);
        
        subSpace = vec(:,2:end);
        % find the projection of the ms_update on the subspace of the eigenvectors
        pcUpdate_normal = subSpace*subSpace'*ms_update(1:3);
        
        % correct the propogation vector and use a stepsize to propogate
        stepSize = 1;
        %   stepSize = vec(:,1)'*normc(pcUpdate_tangent_prev(1:3));
        
        tangVec = stepSize*vec(:,1);
        
        if bifCheck
            tangVec =tangVec*sign(tangVec(1:3)'*tracingUpdate_prev(1:3));   %or use the previous iteration direction
        else
            tangVec = tangVec*sign(tangVec(1:3)'*pcUpdate_tangent_prev); %correct the sign using previous filter estimate
        end
        
        if params.remCheck & t<lenTang %update couple times with the initial direction
            pcUpdate_tangent = 0.1*tangVec+.9*tangVecprev;
        else
            pc_tanget(:,1) = tangVec(1:3);
            if t<lenTang % get the running-average/median of the direction
                pcUpdate_tangent = pc_tanget(:,1:t)*(wTang(1:t)/sum(wTang(1:t)))';
            else
                pcUpdate_tangent = pc_tanget*wTang';
                % pcUpdate_tangent = median(pc_tanget,2);
            end
        end
        
        if pcUpdate_tangent'*[0;1;0]<0
            stop=1;
        end
        if bifCheck
            tracingUpdate = (pcUpdate_tangent+ 1*pcUpdate_normal).*[params.zdist;1;1];  %update the filter
        else
            tracingUpdate = (pcUpdate_tangent + pcUpdate_normal).*[params.zdist;1;1];  %update the filter
        end
        % tracingUpdate = pcUpdate_tangent+pcUpdate_normal; %update the projection
    end
    
    Trajectory_fSub(:,t) = currP + pcUpdate_normal.*[params.zdist;1;1];
    
    [Y,X,Z]=meshgrid(1:3,1:3,1:3);
    V=[params.zdist*(X(:)-2) Y(:)-2 Z(:)-2]';
    
    neig = round((repmat(currP,1,27)+V)./repmat([params.zdist;1;1],1,27));
    % check boundary conditions
    lowbound = any((neig<repmat([1;1;1],1,27)));
    highbound = any((neig>repmat(dim',1,27)));
    bound = lowbound | highbound;
    neig(:,bound) = round(repmat(neig(:,14),1,sum(bound)));
    
    backg = IndI(sub2ind(dim(1:3),neig(1,:),neig(2,:),neig(3,:)))==0;
    neig(:,backg) = repmat(neig(:,14),1,sum(backg));
    
    fneig = f(IndI(sub2ind(dim(1:3),neig(1,:),neig(2,:),neig(3,:))),:);
    fvec = fneig-repmat(fneig(14,:),27,1);
    V_ = normc(V(1:params.featDimP,:));   %All possible 1-st order neighbors
    V_vprev = normc(Vprev)'*V_;
    indprev=find(all(repmat(-normc(Vprev),1,size(V_,2))==V_,1));    %delete the one that we were
    fvec(backg,:) = inf;
    fvec(indprev,:) = inf;
    fvec(bound,:) = inf;
    fvec(14,:) = inf;
    
    coln = fvec(:,params.featDimP+1:end).^2;    % based on similarity between voxels
    sccol = 1;  %sccol = inf;
    
    if params.remCheck
        coln2 = fneig(:,4).^(params.Factors.neig); % based on intensity of the voxel
    else
        coln2 = fneig(:,4).^(params.Factors.neig).*V_vprev(:).^(params.Factors.vprev); % based on intensity of the voxel
    end
    coln2(backg|bound) = 0;
    coln2([14 indprev]) = 0;
    coln2(coln2<0)=0;
    
    % lvec=V_'*tracingUpdate(1:3);    % all inner products of the update
    lvec=V_'*normc(tracingUpdate(1:3));    % all inner products of the update
    lvec(isnan(lvec(:))) = 0;
    lvec(lvec<0)=0;
    
    if bifCheck
        objfunc = lvec.*coln2;%exp(-(coln/sccol));
    else
        objfunc = lvec.*exp(-(coln/sccol)).^5;
    end
    if any(isnan(objfunc)) | all(~objfunc)
        bifurFlag =0;
        break;
    end
    
    [~,updateIndex]=sort(objfunc,'descend');
    p_i_f_next = currP + V(1:params.featDimP,updateIndex(1));
    p_i_next = round(p_i_f_next./[params.zdist;1;1]);
    
    Vprev = V(1:params.featDimP,updateIndex(1));    %swap voxel update
    
    tracingUpdate_prev = V(1:params.featDimP,updateIndex(1));  %swap tracing update
    pcUpdate_tangent_prev = pcUpdate_tangent;  %swap pctangent estimate;
    
    tracedVoxels = setdiff(PCAll,0);
    tracedVoxelsK = KNNG(tracedVoxels,end-27:end);
    tracedVoxelsK = unique(tracedVoxelsK(:));   % all previous tracings with 1st order neighborhod
    
    if any(p_i_next<[1;1;1]) | any(p_i_next'>dim(1:params.featDimP)-[5 5 5])
        break;
    end
    
    indNext = sub2ind(dim(1:3),p_i_next(1),p_i_next(2),p_i_next(3));
    indexOfVoxel = IndI(indNext);
    
    if any(tracedVoxelsK==indexOfVoxel) & ~bifurFlag & ~params.remCheck
        Trajectory(t+1)=indexOfVoxel;   %connect the branch to mainstream
        Trajectory_fSub(:,t+1) = f(indexOfVoxel,1:3);
        break;
        %         end
    end
    if bifCheck
        if params.visual
            figure(gcf),
            hold on,plot3(p_i_f_next(3),p_i_f_next(2),p_i_f_next(1),'r*')
        end
        
        xbif = (Trajectory_fSub(1:3,Trajectory>0))';
        y = f(PCAll,1:3);
        [valmin bifC] = min(pdist2(xbif,y),[],2);
        if any(valmin< 3)
            % iterate until it inflates
            bifurFlag =1;
            if any(valmin<1)
                bifurTrace.traj = Trajectory(Trajectory>0);
                bifurTrace.fSub = f(Trajectory(Trajectory>0),1:3)';
                bifurTrace.parentNode = PCAll(bifC(end));
                bifurTrace.valmin = min(valmin);
                return;
            else %check for inflection
                if sum(diff(valmin(end-min(5,length(valmin)-1):end),1)>0)>2 | any(tracedVoxelsK==indexOfVoxel)
                    [~,indmin]=min(valmin);
                    bifurTrace.traj = Trajectory(1:indmin);
                    bifurTrace.fSub = f(Trajectory(1:indmin),1:3)';
                    bifurTrace.parentNode = PCAll(bifC(end));
                    bifurTrace.valmin = min(valmin);
                    return;
                end
                
            end
        else
            if length(valmin)>5
                if all(diff(valmin(end-5:end),1)>0)
                    bifurFlag =0;
                    return;
                end
            end
        end
    end
    
    %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ~indexOfVoxel |  any(Trajectory==indexOfVoxel)
        break;
    end
    
    pcf = circshift(pcf,[0 1]); %shift pc color buffer
    pc_tanget = circshift(pc_tanget,[0 1]); %shift pc position buffer
    
    tangVec_prev=tangVec;
    
    t=t+1;
    if t>1450
        break;
    end
    
end

if ~bifCheck
    if initSeed~=params.initSeed
        PC{numOfFiber}.Trajectory=[initSeed Trajectory(Trajectory>0)];
        PC{numOfFiber}.Trajectory_fSub=[f(initSeed,1:3)',Trajectory_fSub(:,all(Trajectory_fSub>0))];
    else
        PC{numOfFiber}.Trajectory=Trajectory(Trajectory>0);
        PC{numOfFiber}.Trajectory_fSub=Trajectory_fSub(:,all(Trajectory_fSub>0));
    end
end
end

